function [ filtOut loopFilter ] = LoopFilter( loopFilter, codeDiscr )

% Run the loop filter

% 1) Update the filter input
loopFilter.inputValues( 2:end ) = loopFilter.inputValues( 1:(end - 1) );
loopFilter.inputValues( 1 ) = codeDiscr;

% 2) Evaluate the filter output
filtOut = sum( loopFilter.inputValues .* loopFilter.B ) ...
          - sum( loopFilter.outputValues .* loopFilter.A );

% 3) Update the filter output
loopFilter.outputValues( 2:end ) = loopFilter.outputValues( 1:(end - 1) );
loopFilter.outputValues( 1 ) = filtOut;
